<!DOCTYPE html>
<html>
	<body>
		<p>Click the button to solve the question 3 solution.</p>
		<button onclick="matrixPath()">matrix path</button>
		<p id="demo"></p>

		<script>
			function matrixPath() {
				var n;
                var i,j;
                var ou;
                var sor_x,sor_y;
                var des_x,des_y;
				var output = "";
				var test_case = prompt("Please enter no of test case : ");
				for(p=0;p<test_case;p++) {
					n = +(prompt(`Please enter size of matrices for ${p+1} test: `));
                    var array = new Array(n);
                    var visited = new Array(n);
                    var sourceArray = [];
                    var source = [];
                    var flag = 0;
                    for(i=0;i<n;i++)
                    {
                        array[i] = new Array(n);
                        visited[i] = new Array(n);
                        for(j=0;j<n;j++)
                        {
                            array[i][j] = +(prompt(`Please enter [${i}][${j}] element for ${p+1} test:`));
                            visited[i][j] = 0;
                            if(array[i][j] == 1){
                                sor_x = i;
                                sor_y = j;
                            }
                            if(array[i][j] == 2){
                                des_x = i;
                                des_y = j;
                            }
                        }
                    }
                    var temp = [sor_x,sor_y];
                    sourceArray.push(temp);
                    Loop1 : while(sourceArray.length != 0) {
                        var temp1 = sourceArray[0][0];
                        var temp2 = sourceArray[0][1];
                        source.push([temp1,temp2]);
                        console.log(temp1+"    "+temp2);
                        if(source[0][0]>=0 && source[0][0]<n && source[0][1]>=0 && source[0][1]<n && visited[temp1][temp2] != 1 && array[temp1][temp2] != 0)
                        {
                            if(array[temp1][temp2] == 2)
                            {
    
                                flag =1;
                                break Loop1;
                            }
                            visited[temp1][temp2] = 1;
                            sourceArray.push([temp1+1,temp2]);
                            sourceArray.push([temp1-1,temp2]);
                            sourceArray.push([temp1,temp2+1]);
                            sourceArray.push([temp1,temp2-1]);
                            console.log("array is "+source);
                            console.log("sourceArray is ="+sourceArray)
                            source.shift();
                            console.log("array is "+source);
                        }
                        else
                        {
                            source.shift();
                            console.log("array is "+source);
                        }
                        sourceArray.shift();
                        console.log("sourceArray is "+sourceArray);

                    }
                    if(flag == 1)
                        ou = 1;
                    else
                        ou = 0;
                    output += `Your ${p+1} for path : `+ou+"<br><br><br>";
				}	
				document.getElementById("demo").innerHTML = output;
			}
		</script>

	</body>
</html>